Module | EventMachine::Protocols::SASLauth
In: | lib/protocols/saslauth.rb

Implements SASL authd. This is a very, very simple protocol that mimics the one used by saslauthd and pwcheck, two outboard daemons included in the standard SASL library distro. The only thing this is really suitable for is SASL PLAIN (user+password) authentication, but the SASL libs that are linked into standard servers (like imapd and sendmail) implement the other ones.

SASL-auth is intended for reasonably fast operation inside a single machine, so it has no transport-security (although there have been multi-machine extensions incorporating transport-layer encryption).

The standard saslauthd module generally runs privileged and does its work by referring to the system-account files.

This feature was added to EventMachine to enable the development of custom authentication/authorization engines for standard servers.

To use SASLauth, include it in a class that subclasses EM::Connection, and reimplement the validate method.

The typical way to incorporate this module into an authentication daemon would be to set it as the handler for a UNIX-domain socket. The code might look like this:

     EM.start_unix_domain_server( "/var/run/saslauthd/mux", MyHandler )
     File.chmod( 0777, "/var/run/saslauthd/mux")

The chmod is probably needed to ensure that unprivileged clients can access the UNIX-domain socket.

It‘s also a very good idea to drop superuser privileges (if any), after the UNIX-domain socket has been opened.

### Methods

post_init receive_data validate

### Constants

MaxFieldSize | = | 128*1024

### Public Instance methods

post_init()
receive_data(data)
validate(username, psw, sysname, realm)

[Validate]